<?php

class Ips {

	var	$ip_
	,	$time_
	,	$isNew_ = true
	,	$ips_ = array();
	var	$modId_ = null;
	var $file_ = null
	,	$dir_ = null
	,	$dirData_ = null;


	function Ips($modId, $ip) {
		$this->modId_ = $modId;
		$this->dirData_ = '../data/';
		$this->dir_ = $this->dirData_.$this->modId_.'/';
		$this->file_ = $this->dir_.'ips';
		$this->ip_ = $ip;
		$this->time_ = time();
		$ips = array();
		if (file_exists($this->file_)) {
			$ips = file($this->file_);
		}
		foreach ($ips as $val) {
			list($ip, $time) = explode(' ', $val);
			if ($this->ip_==$ip && (($this->time_-$time)<(60*30))) {
				$this->isNew_ = false;
			} elseif (($this->time_-$time)<60*30) {
				array_push($this->ips_, $val);
			}
		}
	}

	function IsNew() {
		return $this->isNew_;
	}

	function AppendCurrentIp() {
		if (!$this->_PrepareStorage()) {
			return false;
		}
		$f = fopen($this->file_, 'w');
		if ($f) {
			array_push($this->ips_, "{$this->ip_} {$this->time_}");
			fwrite($f, implode("\n", $this->ips_));
			fclose($f);
			chmod($this->file_, 0666);
			return true;
		}
		return false;
	}

	function _PrepareStorage() {
		if (file_exists($this->dir_)) {
			return is_dir($this->dir_);
		}
		$dirs = explode('/', $this->dir_);
		if (empty($dirs[0])) {
			$dirs[0] = '/';
		}
		$base = '';
		foreach ($dirs as $dir) {
			$base .= "$dir/";
			if (!file_exists($base)) {
				mkdir($base);
				chmod($base, 0777);
			} else if (!is_dir($base)) {
				return false;
			}
		}
		return true;
	}

}

?>